"use strict";

var _Object$defineProperty = require("@babel/runtime-corejs2/core-js/object/define-property");

_Object$defineProperty(exports, "__esModule", {
  value: true
});

exports.default = void 0;

var _reactRedux = require("react-redux");

var _redux = require("redux");

var _recompose = require("recompose");

var _reactComponentUtils = require("@ciscospark/react-component-utils");

var _actions = require("./actions");

var _default = (0, _recompose.compose)((0, _reactComponentUtils.setWrappedDisplayName)('WithMedia'), (0, _reactRedux.connect)(function (state) {
  return {
    sparkInstance: state.spark.get('spark'),
    media: state.media
  };
}, function (dispatch) {
  return (0, _redux.bindActionCreators)({
    checkCurrentCalls: _actions.checkCurrentCalls,
    checkWebRTCSupport: _actions.checkWebRTCSupport,
    listenForCalls: _actions.listenForCalls,
    registerClient: _actions.registerClient
  }, dispatch);
}), (0, _recompose.lifecycle)({
  componentWillReceiveProps: function componentWillReceiveProps(nextProps) {
    var media = nextProps.media,
        sparkInstance = nextProps.sparkInstance;

    if (sparkInstance) {
      if (!media.webRTC.hasCheckedSupport) {
        nextProps.checkWebRTCSupport(sparkInstance);
      } else if (!media.status.isRegistered && !media.status.isRegistering) {
        nextProps.registerClient(sparkInstance);
      } else if (!media.status.isListening) {
        // Check if there are any existing calls and store them
        nextProps.checkCurrentCalls(sparkInstance); // Listen for new calls

        nextProps.listenForCalls(sparkInstance);
      }
    }
  }
}));

exports.default = _default;